commit 8bb7567f5a3e67ab91614d4538eb3a14a5a76274
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Tue Jun 28 22:29:28 2022 +0200

    Fortran: improve error recovery for EXTENDS_TYPE_OF() [PR106121]
    
    gcc/fortran/ChangeLog:
    
            PR fortran/106121
            * simplify.c (gfc_simplify_extends_type_of): Do not attempt to
            simplify when one of the arguments is a CLASS variable that was
            not properly declared.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/106121
            * gfortran.dg/extends_type_of_4.f90: New test.
    
    Co-authored-by: Steven G. Kargl <kargl@gcc.gnu.org>
    (cherry picked from commit b8f284d3673004dffae714b56ed663467c2a52a7)

diff --git a/gcc/fortran/simplify.c b/gcc/fortran/simplify.c
index a4e014a746f..29d4c695302 100644
--- a/gcc/fortran/simplify.c
+++ b/gcc/fortran/simplify.c
@@ -3060,6 +3060,10 @@ gfc_simplify_extends_type_of (gfc_expr *a, gfc_expr *mold)
   if (UNLIMITED_POLY (a) || UNLIMITED_POLY (mold))
     return NULL;
 
+  if ((a->ts.type == BT_CLASS && !gfc_expr_attr (a).class_ok)
+      || (mold->ts.type == BT_CLASS && !gfc_expr_attr (mold).class_ok))
+    return NULL;
+
   /* Return .false. if the dynamic type can never be an extension.  */
   if ((a->ts.type == BT_CLASS && mold->ts.type == BT_CLASS
        && !gfc_type_is_extension_of
diff --git a/gcc/testsuite/gfortran.dg/extends_type_of_4.f90 b/gcc/testsuite/gfortran.dg/extends_type_of_4.f90
new file mode 100644
index 00000000000..64373322387
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/extends_type_of_4.f90
@@ -0,0 +1,20 @@
+! { dg-do compile }
+! PR fortran/106121 - ICE in gfc_simplify_extends_type_of
+! Contributed by G.Steinmetz
+
+program p
+   type t
+   end type
+   type(t)  :: x
+   class(t) :: y               ! { dg-error "dummy, allocatable or pointer" }
+   print *, extends_type_of (x, y)
+end
+
+subroutine s
+   type t
+      integer :: i
+   end type
+   type(t)  :: x
+   class(t) :: y               ! { dg-error "dummy, allocatable or pointer" }
+   stop extends_type_of (x, y) ! { dg-error "STOP code" }
+end

